Index: sys/netinet/ip_input.c
===================================================================
--- sys/netinet/ip_input.c	(revision 195689)
+++ sys/netinet/ip_input.c	(working copy)
@@ -71,10 +71,10 @@
 #include <netinet/ip.h>
 #include <netinet/in_pcb.h>
 #include <netinet/ip_var.h>
+#include <netinet/ip_fw.h>
 #include <netinet/ip_icmp.h>
 #include <netinet/ip_options.h>
 #include <machine/in_cksum.h>
-#include <netinet/vinet.h>
 #ifdef DEV_CARP
 #include <netinet/ip_carp.h>
 #endif
@@ -90,58 +90,69 @@
 CTASSERT(sizeof(struct ip) == 20);
 #endif
 
-#ifndef VIMAGE
-#ifndef VIMAGE_GLOBALS
-struct vnet_inet vnet_inet_0;
-#endif
-#endif
+static VNET_DEFINE(int, ipsendredirects) = 1;	/* XXX */
+static VNET_DEFINE(int, ip_checkinterface);
+static VNET_DEFINE(int, ip_keepfaith);
+static VNET_DEFINE(int, ip_sendsourcequench);
 
-#ifdef VIMAGE_GLOBALS
-static int	ipsendredirects;
-static int	ip_checkinterface;
-static int	ip_keepfaith;
-static int	ip_sendsourcequench;
-int	ip_defttl;
-int	ip_do_randomid;
-int	ipforwarding;
-struct	in_ifaddrhead in_ifaddrhead; 		/* first inet address */
-struct	in_ifaddrhashhead *in_ifaddrhashtbl;	/* inet addr hash table  */
-u_long 	in_ifaddrhmask;				/* mask for hash table */
-struct ipstat ipstat;
-static int ip_rsvp_on;
-struct socket *ip_rsvpd;
-int	rsvp_on;
-static struct ipqhead ipq[IPREASS_NHASH];
-static int	maxnipq;	/* Administrative limit on # reass queues. */
-static int	maxfragsperpacket;
-int	ipstealth;
-static int	nipq;	/* Total # of reass queues */
-#endif
+#define	V_ipsendredirects	VNET_GET(ipsendredirects)
+#define	V_ip_checkinterface	VNET_GET(ip_checkinterface)
+#define	V_ip_keepfaith		VNET_GET(ip_keepfaith)
+#define	V_ip_sendsourcequench	VNET_GET(ip_sendsourcequench)
 
+VNET_DEFINE(int, ip_defttl) = IPDEFTTL;
+VNET_DEFINE(int, ip_do_randomid);
+VNET_DEFINE(int, ipforwarding);
+
+VNET_DEFINE(struct in_ifaddrhead, in_ifaddrhead);  /* first inet address */
+VNET_DEFINE(struct in_ifaddrhashhead *, in_ifaddrhashtbl); /* inet addr hash table  */
+VNET_DEFINE(u_long, in_ifaddrhmask);		/* mask for hash table */
+VNET_DEFINE(struct ipstat, ipstat);
+
+static VNET_DEFINE(int, ip_rsvp_on);
+VNET_DEFINE(struct socket *, ip_rsvpd);
+VNET_DEFINE(int, rsvp_on);
+
+#define	V_ip_rsvp_on		VNET_GET(ip_rsvp_on)
+
+static VNET_DEFINE(TAILQ_HEAD(ipqhead, ipq), ipq[IPREASS_NHASH]);
+static VNET_DEFINE(int, maxnipq);  /* Administrative limit on # reass queues. */
+static VNET_DEFINE(int, maxfragsperpacket);
+static VNET_DEFINE(int, nipq);			/* Total # of reass queues */
+
+#define	V_ipq			VNET_GET(ipq)
+#define	V_maxnipq		VNET_GET(maxnipq)
+#define	V_maxfragsperpacket	VNET_GET(maxfragsperpacket)
+#define	V_nipq			VNET_GET(nipq)
+
+VNET_DEFINE(int, ipstealth);
+
 struct	rwlock in_ifaddr_lock;
 RW_SYSINIT(in_ifaddr_lock, &in_ifaddr_lock, "in_ifaddr_lock");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, IPCTL_FORWARDING,
-    forwarding, CTLFLAG_RW, ipforwarding, 0,
+SYSCTL_VNET_INT(_net_inet_ip, IPCTL_FORWARDING, forwarding, CTLFLAG_RW,
+    &VNET_NAME(ipforwarding), 0,
     "Enable IP forwarding between interfaces");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, IPCTL_SENDREDIRECTS,
-    redirect, CTLFLAG_RW, ipsendredirects, 0,
+SYSCTL_VNET_INT(_net_inet_ip, IPCTL_SENDREDIRECTS, redirect, CTLFLAG_RW,
+    &VNET_NAME(ipsendredirects), 0,
     "Enable sending IP redirects");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, IPCTL_DEFTTL,
-    ttl, CTLFLAG_RW, ip_defttl, 0, "Maximum TTL on IP packets");
+SYSCTL_VNET_INT(_net_inet_ip, IPCTL_DEFTTL, ttl, CTLFLAG_RW,
+    &VNET_NAME(ip_defttl), 0,
+    "Maximum TTL on IP packets");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, IPCTL_KEEPFAITH,
-    keepfaith, CTLFLAG_RW, ip_keepfaith,	0,
+SYSCTL_VNET_INT(_net_inet_ip, IPCTL_KEEPFAITH, keepfaith, CTLFLAG_RW,
+    &VNET_NAME(ip_keepfaith), 0,
     "Enable packet capture for FAITH IPv4->IPv6 translater daemon");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, OID_AUTO,
-    sendsourcequench, CTLFLAG_RW, ip_sendsourcequench, 0,
+SYSCTL_VNET_INT(_net_inet_ip, OID_AUTO, sendsourcequench, CTLFLAG_RW,
+    &VNET_NAME(ip_sendsourcequench), 0,
     "Enable the transmission of source quench packets");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, OID_AUTO, random_id,
-    CTLFLAG_RW, ip_do_randomid, 0, "Assign random ip_id values");
+SYSCTL_VNET_INT(_net_inet_ip, OID_AUTO, random_id, CTLFLAG_RW,
+    &VNET_NAME(ip_do_randomid), 0,
+    "Assign random ip_id values");
 
 /*
  * XXX - Setting ip_checkinterface mostly implements the receive side of
@@ -156,8 +167,8 @@
  * to the loopback interface instead of the interface where the
  * packets for those addresses are received.
  */
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, OID_AUTO,
-    check_interface, CTLFLAG_RW, ip_checkinterface, 0,
+SYSCTL_VNET_INT(_net_inet_ip, OID_AUTO, check_interface, CTLFLAG_RW,
+    &VNET_NAME(ip_checkinterface), 0,
     "Verify packet arrives on correct interface");
 
 struct pfil_head inet_pfil_hook;	/* Packet filter hooks */
@@ -173,13 +184,13 @@
 extern	struct protosw inetsw[];
 u_char	ip_protox[IPPROTO_MAX];
 
+SYSCTL_VNET_STRUCT(_net_inet_ip, IPCTL_STATS, stats, CTLFLAG_RW,
+    &VNET_NAME(ipstat), ipstat,
+    "IP statistics (struct ipstat, netinet/ip_var.h)");
 
-SYSCTL_V_STRUCT(V_NET, vnet_inet, _net_inet_ip, IPCTL_STATS, stats, CTLFLAG_RW,
-    ipstat, ipstat, "IP statistics (struct ipstat, netinet/ip_var.h)");
+static VNET_DEFINE(uma_zone_t, ipq_zone);
+#define	V_ipq_zone		VNET_GET(ipq_zone)
 
-#ifdef VIMAGE_GLOBALS
-static uma_zone_t ipq_zone;
-#endif
 static struct mtx ipqlock;
 
 #define	IPQ_LOCK()	mtx_lock(&ipqlock)
@@ -190,12 +201,12 @@
 static void	maxnipq_update(void);
 static void	ipq_zone_change(void *);
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, OID_AUTO, fragpackets,
-    CTLFLAG_RD, nipq, 0,
+SYSCTL_VNET_INT(_net_inet_ip, OID_AUTO, fragpackets, CTLFLAG_RD,
+    &VNET_NAME(nipq), 0,
     "Current number of IPv4 fragment reassembly queue entries");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, OID_AUTO, maxfragsperpacket,
-    CTLFLAG_RW, maxfragsperpacket, 0,
+SYSCTL_VNET_INT(_net_inet_ip, OID_AUTO, maxfragsperpacket, CTLFLAG_RW,
+    &VNET_NAME(maxfragsperpacket), 0,
     "Maximum number of IPv4 fragments allowed per packet");
 
 struct callout	ipport_tick_callout;
@@ -206,32 +217,32 @@
 #endif
 
 #ifdef IPSTEALTH
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, OID_AUTO, stealth, CTLFLAG_RW,
-    ipstealth, 0, "IP stealth mode, no TTL decrementation on forwarding");
+SYSCTL_VNET_INT(_net_inet_ip, OID_AUTO, stealth, CTLFLAG_RW,
+    &VNET_NAME(ipstealth), 0,
+    "IP stealth mode, no TTL decrementation on forwarding");
 #endif
+
 #ifdef FLOWTABLE
-#ifdef VIMAGE_GLOBALS
-static int ip_output_flowtable_size;
-struct flowtable *ip_ft;
-#endif
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_ip, OID_AUTO, output_flowtable_size,
-    CTLFLAG_RDTUN, ip_output_flowtable_size, 2048,
+static VNET_DEFINE(int, ip_output_flowtable_size) = 2048;
+VNET_DEFINE(struct flowtable *, ip_ft);
+#define	V_ip_output_flowtable_size	VNET_GET(ip_output_flowtable_size)
+
+SYSCTL_VNET_INT(_net_inet_ip, OID_AUTO, output_flowtable_size, CTLFLAG_RDTUN,
+    &VNET_NAME(ip_output_flowtable_size), 2048,
     "number of entries in the per-cpu output flow caches");
 #endif
 
-#ifdef VIMAGE_GLOBALS
-int fw_one_pass;
-#endif
+VNET_DEFINE(int, fw_one_pass) = 1;
 
 static void	ip_freef(struct ipqhead *, struct ipq *);
 
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
+/* XXX only has to stay for .vmi_dependson elsewhere. */
 static void vnet_inet_register(void);
  
 static const vnet_modinfo_t vnet_inet_modinfo = {
 	.vmi_id		= VNET_MOD_INET,
 	.vmi_name	= "inet",
-	.vmi_size	= sizeof(struct vnet_inet)
 };
  
 static void vnet_inet_register()
@@ -288,44 +299,11 @@
 void
 ip_init(void)
 {
-	INIT_VNET_INET(curvnet);
 	struct protosw *pr;
 	int i;
 
-	V_ipsendredirects = 1; /* XXX */
-	V_ip_checkinterface = 0;
-	V_ip_keepfaith = 0;
-	V_ip_sendsourcequench = 0;
-	V_rsvp_on = 0;
-	V_ip_defttl = IPDEFTTL;
-	V_ip_do_randomid = 0;
 	V_ip_id = time_second & 0xffff;
-	V_ipforwarding = 0;
-	V_ipstealth = 0;
-	V_nipq = 0;	/* Total # of reass queues */
 
-	V_ipport_lowfirstauto = IPPORT_RESERVED - 1;	/* 1023 */
-	V_ipport_lowlastauto = IPPORT_RESERVEDSTART;	/* 600 */
-	V_ipport_firstauto = IPPORT_EPHEMERALFIRST;	/* 10000 */
-	V_ipport_lastauto = IPPORT_EPHEMERALLAST;	/* 65535 */
-	V_ipport_hifirstauto = IPPORT_HIFIRSTAUTO;	/* 49152 */
-	V_ipport_hilastauto = IPPORT_HILASTAUTO;	/* 65535 */
-	V_ipport_reservedhigh = IPPORT_RESERVED - 1;	/* 1023 */
-	V_ipport_reservedlow = 0;
-	V_ipport_randomized = 1;	/* user controlled via sysctl */
-	V_ipport_randomcps = 10;	/* user controlled via sysctl */
-	V_ipport_randomtime = 45;	/* user controlled via sysctl */
-	V_ipport_stoprandom = 0;	/* toggled by ipport_tick */
-
-	V_fw_one_pass = 1;
-
-#ifdef NOTYET
-	/* XXX global static but not instantiated in this file */
-	V_ipfastforward_active = 0;
-	V_subnetsarelocal = 0;
-	V_sameprefixcarponly = 0;
-#endif
-
 	TAILQ_INIT(&V_in_ifaddrhead);
 	V_in_ifaddrhashtbl = hashinit(INADDR_NHASH, M_IFADDR, &V_in_ifaddrhmask);
 
@@ -339,7 +317,6 @@
 	maxnipq_update();
 
 #ifdef FLOWTABLE
-	V_ip_output_flowtable_size = 2048;
 	TUNABLE_INT_FETCH("net.inet.ip.output_flowtable_size",
 	    &V_ip_output_flowtable_size);
 	V_ip_ft = flowtable_alloc(V_ip_output_flowtable_size, FL_PCPU);
@@ -403,7 +380,6 @@
 void
 ip_input(struct mbuf *m)
 {
-	INIT_VNET_INET(curvnet);
 	struct ip *ip = NULL;
 	struct in_ifaddr *ia = NULL;
 	struct ifaddr *ifa;
@@ -808,7 +784,6 @@
 static void
 maxnipq_update(void)
 {
-	INIT_VNET_INET(curvnet);
 
 	/*
 	 * -1 for unlimited allocation.
@@ -832,7 +807,6 @@
 static void
 ipq_zone_change(void *tag)
 {
-	INIT_VNET_INET(curvnet);
 
 	if (V_maxnipq > 0 && V_maxnipq < (nmbclusters / 32)) {
 		V_maxnipq = nmbclusters / 32;
@@ -843,7 +817,6 @@
 static int
 sysctl_maxnipq(SYSCTL_HANDLER_ARGS)
 {
-	INIT_VNET_INET(curvnet);
 	int error, i;
 
 	i = V_maxnipq;
@@ -879,7 +852,6 @@
 struct mbuf *
 ip_reass(struct mbuf *m)
 {
-	INIT_VNET_INET(curvnet);
 	struct ip *ip;
 	struct mbuf *p, *q, *nq, *t;
 	struct ipq *fp = NULL;
@@ -1195,7 +1167,6 @@
 static void
 ip_freef(struct ipqhead *fhp, struct ipq *fp)
 {
-	INIT_VNET_INET(curvnet);
 	struct mbuf *q;
 
 	IPQ_LOCK_ASSERT();
@@ -1226,7 +1197,6 @@
 	VNET_LIST_RLOCK();
 	VNET_FOREACH(vnet_iter) {
 		CURVNET_SET(vnet_iter);
-		INIT_VNET_INET(vnet_iter);
 		for (i = 0; i < IPREASS_NHASH; i++) {
 			for(fp = TAILQ_FIRST(&V_ipq[i]); fp;) {
 				struct ipq *fpp;
@@ -1275,7 +1245,6 @@
 	VNET_LIST_RLOCK();
 	VNET_FOREACH(vnet_iter) {
 		CURVNET_SET(vnet_iter);
-		INIT_VNET_INET(vnet_iter);
 		for (i = 0; i < IPREASS_NHASH; i++) {
 			while(!TAILQ_EMPTY(&V_ipq[i])) {
 				IPSTAT_ADD(ips_fragdropped,
@@ -1403,7 +1372,6 @@
 void
 ip_forward(struct mbuf *m, int srcrt)
 {
-	INIT_VNET_INET(curvnet);
 	struct ip *ip = mtod(m, struct ip *);
 	struct in_ifaddr *ia;
 	struct mbuf *mcopy;
@@ -1638,7 +1606,6 @@
 ip_savecontrol(struct inpcb *inp, struct mbuf **mp, struct ip *ip,
     struct mbuf *m)
 {
-	INIT_VNET_NET(inp->inp_vnet);
 
 	if (inp->inp_socket->so_options & (SO_BINTIME | SO_TIMESTAMP)) {
 		struct bintime bt;
@@ -1736,7 +1703,6 @@
 int
 ip_rsvp_init(struct socket *so)
 {
-	INIT_VNET_INET(so->so_vnet);
 
 	if (so->so_type != SOCK_RAW ||
 	    so->so_proto->pr_protocol != IPPROTO_RSVP)
@@ -1761,7 +1727,6 @@
 int
 ip_rsvp_done(void)
 {
-	INIT_VNET_INET(curvnet);
 
 	V_ip_rsvpd = NULL;
 	/*
@@ -1778,7 +1743,6 @@
 void
 rsvp_input(struct mbuf *m, int off)	/* XXX must fixup manually */
 {
-	INIT_VNET_INET(curvnet);
 
 	if (rsvp_input_p) { /* call the real one if loaded */
 		rsvp_input_p(m, off);
Index: sys/netinet/tcp_usrreq.c
===================================================================
--- sys/netinet/tcp_usrreq.c	(revision 195689)
+++ sys/netinet/tcp_usrreq.c	(working copy)
@@ -87,7 +87,6 @@
 #include <netinet/tcp_debug.h>
 #endif
 #include <netinet/tcp_offload.h>
-#include <netinet/vinet.h>
 
 /*
  * TCP protocol interface to socket abstraction.
@@ -157,9 +156,6 @@
 tcp_detach(struct socket *so, struct inpcb *inp)
 {
 	struct tcpcb *tp;
-#ifdef INVARIANTS
-	INIT_VNET_INET(so->so_vnet);
-#endif
 
 	INP_INFO_WLOCK_ASSERT(&V_tcbinfo);
 	INP_WLOCK_ASSERT(inp);
@@ -221,7 +217,6 @@
 static void
 tcp_usr_detach(struct socket *so)
 {
-	INIT_VNET_INET(so->so_vnet);
 	struct inpcb *inp;
 
 	inp = sotoinpcb(so);
@@ -240,7 +235,6 @@
 static int
 tcp_usr_bind(struct socket *so, struct sockaddr *nam, struct thread *td)
 {
-	INIT_VNET_INET(so->so_vnet);
 	int error = 0;
 	struct inpcb *inp;
 	struct tcpcb *tp = NULL;
@@ -281,7 +275,6 @@
 static int
 tcp6_usr_bind(struct socket *so, struct sockaddr *nam, struct thread *td)
 {
-	INIT_VNET_INET(so->so_vnet);
 	int error = 0;
 	struct inpcb *inp;
 	struct tcpcb *tp = NULL;
@@ -340,7 +333,6 @@
 static int
 tcp_usr_listen(struct socket *so, int backlog, struct thread *td)
 {
-	INIT_VNET_INET(so->so_vnet);
 	int error = 0;
 	struct inpcb *inp;
 	struct tcpcb *tp = NULL;
@@ -378,7 +370,6 @@
 static int
 tcp6_usr_listen(struct socket *so, int backlog, struct thread *td)
 {
-	INIT_VNET_INET(so->so_vnet);
 	int error = 0;
 	struct inpcb *inp;
 	struct tcpcb *tp = NULL;
@@ -426,7 +417,6 @@
 static int
 tcp_usr_connect(struct socket *so, struct sockaddr *nam, struct thread *td)
 {
-	INIT_VNET_INET(so->so_vnet);
 	int error = 0;
 	struct inpcb *inp;
 	struct tcpcb *tp = NULL;
@@ -469,7 +459,6 @@
 static int
 tcp6_usr_connect(struct socket *so, struct sockaddr *nam, struct thread *td)
 {
-	INIT_VNET_INET(so->so_vnet);
 	int error = 0;
 	struct inpcb *inp;
 	struct tcpcb *tp = NULL;
@@ -547,7 +536,6 @@
 static int
 tcp_usr_disconnect(struct socket *so)
 {
-	INIT_VNET_INET(so->so_vnet);
 	struct inpcb *inp;
 	struct tcpcb *tp = NULL;
 	int error = 0;
@@ -579,7 +567,6 @@
 static int
 tcp_usr_accept(struct socket *so, struct sockaddr **nam)
 {
-	INIT_VNET_INET(so->so_vnet);
 	int error = 0;
 	struct inpcb *inp = NULL;
 	struct tcpcb *tp = NULL;
@@ -677,7 +664,6 @@
 static int
 tcp_usr_shutdown(struct socket *so)
 {
-	INIT_VNET_INET(so->so_vnet);
 	int error = 0;
 	struct inpcb *inp;
 	struct tcpcb *tp = NULL;
@@ -745,7 +731,6 @@
 tcp_usr_send(struct socket *so, int flags, struct mbuf *m,
     struct sockaddr *nam, struct mbuf *control, struct thread *td)
 {
-	INIT_VNET_INET(so->so_vnet);
 	int error = 0;
 	struct inpcb *inp;
 	struct tcpcb *tp = NULL;
@@ -901,7 +886,6 @@
 static void
 tcp_usr_abort(struct socket *so)
 {
-	INIT_VNET_INET(so->so_vnet);
 	struct inpcb *inp;
 	struct tcpcb *tp = NULL;
 	TCPDEBUG0;
@@ -940,7 +924,6 @@
 static void
 tcp_usr_close(struct socket *so)
 {
-	INIT_VNET_INET(so->so_vnet);
 	struct inpcb *inp;
 	struct tcpcb *tp = NULL;
 	TCPDEBUG0;
@@ -1079,7 +1062,6 @@
 {
 	struct inpcb *inp = tp->t_inpcb, *oinp;
 	struct socket *so = inp->inp_socket;
-	INIT_VNET_INET(so->so_vnet);
 	struct in_addr laddr;
 	u_short lport;
 	int error;
@@ -1135,7 +1117,6 @@
 {
 	struct inpcb *inp = tp->t_inpcb, *oinp;
 	struct socket *so = inp->inp_socket;
-	INIT_VNET_INET(so->so_vnet);
 	struct sockaddr_in6 *sin6 = (struct sockaddr_in6 *)nam;
 	struct in6_addr addr6;
 	int error;
@@ -1257,7 +1238,6 @@
 int
 tcp_ctloutput(struct socket *so, struct sockopt *sopt)
 {
-	INIT_VNET_INET(so->so_vnet);
 	int	error, opt, optval;
 	struct	inpcb *inp;
 	struct	tcpcb *tp;
@@ -1445,7 +1425,6 @@
 static int
 tcp_attach(struct socket *so)
 {
-	INIT_VNET_INET(so->so_vnet);
 	struct tcpcb *tp;
 	struct inpcb *inp;
 	int error;
@@ -1498,9 +1477,6 @@
 {
 	struct inpcb *inp = tp->t_inpcb;
 	struct socket *so = inp->inp_socket;
-#ifdef INVARIANTS
-	INIT_VNET_INET(so->so_vnet);
-#endif
 
 	INP_INFO_WLOCK_ASSERT(&V_tcbinfo);
 	INP_WLOCK_ASSERT(inp);
@@ -1539,9 +1515,6 @@
 static void
 tcp_usrclosed(struct tcpcb *tp)
 {
-#ifdef INVARIANTS
-	INIT_VNET_INET(tp->t_inpcb->inp_vnet);
-#endif
 
 	INP_INFO_WLOCK_ASSERT(&V_tcbinfo);
 	INP_WLOCK_ASSERT(tp->t_inpcb);
Index: sys/netinet/in_gif.c
===================================================================
--- sys/netinet/in_gif.c	(revision 195689)
+++ sys/netinet/in_gif.c	(working copy)
@@ -59,7 +59,6 @@
 #include <netinet/in_var.h>
 #include <netinet/ip_encap.h>
 #include <netinet/ip_ecn.h>
-#include <netinet/vinet.h>
 
 #ifdef INET6
 #include <netinet/ip6.h>
@@ -86,16 +85,12 @@
 	.pr_usrreqs =		&rip_usrreqs
 };
 
-#ifdef VIMAGE_GLOBALS
-extern int ip_gif_ttl;
-#endif
-SYSCTL_V_INT(V_NET, vnet_gif, _net_inet_ip, IPCTL_GIF_TTL, gifttl,
-	CTLFLAG_RW, ip_gif_ttl,	0, "");
+SYSCTL_VNET_INT(_net_inet_ip, IPCTL_GIF_TTL, gifttl, CTLFLAG_RW,
+	&VNET_NAME(ip_gif_ttl), 0, "");
 
 int
 in_gif_output(struct ifnet *ifp, int family, struct mbuf *m)
 {
-	INIT_VNET_GIF(ifp->if_vnet);
 	struct gif_softc *sc = ifp->if_softc;
 	struct sockaddr_in *dst = (struct sockaddr_in *)&sc->gif_ro.ro_dst;
 	struct sockaddr_in *sin_src = (struct sockaddr_in *)sc->gif_psrc;
@@ -273,7 +268,6 @@
 void
 in_gif_input(struct mbuf *m, int off)
 {
-	INIT_VNET_INET(curvnet);
 	struct ifnet *gifp = NULL;
 	struct gif_softc *sc;
 	struct ip *ip;
@@ -368,7 +362,6 @@
 static int
 gif_validate4(const struct ip *ip, struct gif_softc *sc, struct ifnet *ifp)
 {
-	INIT_VNET_INET(curvnet);
 	struct sockaddr_in *src, *dst;
 	struct in_ifaddr *ia4;
 
Index: sys/netinet/ip_mroute.c
===================================================================
--- sys/netinet/ip_mroute.c	(revision 195689)
+++ sys/netinet/ip_mroute.c	(working copy)
@@ -111,7 +111,6 @@
 #include <netinet/pim.h>
 #include <netinet/pim_var.h>
 #include <netinet/udp.h>
-#include <netinet/vinet.h>
 
 #include <machine/in_cksum.h>
 
@@ -379,7 +378,6 @@
 static int
 X_ip_mrouter_set(struct socket *so, struct sockopt *sopt)
 {
-    INIT_VNET_INET(curvnet);
     int	error, optval;
     vifi_t	vifi;
     struct	vifctl vifc;
@@ -602,7 +600,6 @@
 static void
 if_detached_event(void *arg __unused, struct ifnet *ifp)
 {
-    INIT_VNET_INET(curvnet);
     vifi_t vifi;
     int i;
 
@@ -651,7 +648,6 @@
 static int
 ip_mrouter_init(struct socket *so, int version)
 {
-    INIT_VNET_INET(curvnet);
 
     CTR3(KTR_IPMF, "%s: so_type %d, pr_protocol %d", __func__,
         so->so_type, so->so_proto->pr_protocol);
@@ -699,7 +695,6 @@
 static int
 X_ip_mrouter_done(void)
 {
-    INIT_VNET_INET(curvnet);
     vifi_t vifi;
     int i;
     struct ifnet *ifp;
@@ -1220,7 +1215,6 @@
 X_ip_mforward(struct ip *ip, struct ifnet *ifp, struct mbuf *m,
     struct ip_moptions *imo)
 {
-    INIT_VNET_INET(curvnet);
     struct mfc *rt;
     int error;
     vifi_t vifi;
@@ -1475,7 +1469,6 @@
 static int
 ip_mdq(struct mbuf *m, struct ifnet *ifp, struct mfc *rt, vifi_t xmt_vif)
 {
-    INIT_VNET_INET(curvnet);
     struct ip  *ip = mtod(m, struct ip *);
     vifi_t vifi;
     int plen = ip->ip_len;
@@ -1709,7 +1702,6 @@
 static void
 X_rsvp_input(struct mbuf *m, int off __unused)
 {
-	INIT_VNET_INET(curvnet);
 
 	if (!V_rsvp_on)
 		m_freem(m);
@@ -2044,7 +2036,6 @@
 static void
 bw_upcalls_send(void)
 {
-    INIT_VNET_INET(curvnet);
     struct mbuf *m;
     int len = bw_upcalls_n * sizeof(bw_upcalls[0]);
     struct sockaddr_in k_igmpsrc = { sizeof k_igmpsrc, AF_INET };
@@ -2401,7 +2392,6 @@
 pim_register_send_upcall(struct ip *ip, struct vif *vifp,
     struct mbuf *mb_copy, struct mfc *rt)
 {
-    INIT_VNET_INET(curvnet);
     struct mbuf *mb_first;
     int len = ntohs(ip->ip_len);
     struct igmpmsg *im;
@@ -2454,7 +2444,6 @@
 pim_register_send_rp(struct ip *ip, struct vif *vifp, struct mbuf *mb_copy,
     struct mfc *rt)
 {
-    INIT_VNET_INET(curvnet);
     struct mbuf *mb_first;
     struct ip *ip_outer;
     struct pim_encap_pimhdr *pimhdr;
@@ -2795,7 +2784,6 @@
 static int
 ip_mroute_modevent(module_t mod, int type, void *unused)
 {
-    INIT_VNET_INET(curvnet);
 
     switch (type) {
     case MOD_LOAD:
Index: sys/netinet/icmp_var.h
===================================================================
--- sys/netinet/icmp_var.h	(revision 195689)
+++ sys/netinet/icmp_var.h	(working copy)
@@ -79,9 +79,10 @@
 
 #ifdef _KERNEL
 SYSCTL_DECL(_net_inet_icmp);
-#ifdef VIMAGE_GLOBALS
-extern struct icmpstat icmpstat;	/* icmp statistics */
-#endif
+
+VNET_DECLARE(struct icmpstat, icmpstat);	/* icmp statistics. */
+#define	V_icmpstat	VNET_GET(icmpstat)
+
 extern int badport_bandlim(int);
 #define BANDLIM_UNLIMITED -1
 #define BANDLIM_ICMP_UNREACH 0
Index: sys/netinet/sctp_os_bsd.h
===================================================================
--- sys/netinet/sctp_os_bsd.h	(revision 195689)
+++ sys/netinet/sctp_os_bsd.h	(working copy)
@@ -78,12 +78,10 @@
 #include <netinet/ip_var.h>
 #include <netinet/ip_icmp.h>
 #include <netinet/icmp_var.h>
-#include <netinet/vinet.h>
 
 #ifdef IPSEC
 #include <netipsec/ipsec.h>
 #include <netipsec/key.h>
-#include <netipsec/vipsec.h>
 #endif				/* IPSEC */
 
 #ifdef INET6
@@ -98,7 +96,6 @@
 #include <netinet6/ip6protosw.h>
 #include <netinet6/nd6.h>
 #include <netinet6/scope6_var.h>
-#include <netinet6/vinet6.h>
 #endif				/* INET6 */
 
 
Index: sys/netinet/ip_icmp.c
===================================================================
--- sys/netinet/ip_icmp.c	(revision 195689)
+++ sys/netinet/ip_icmp.c	(working copy)
@@ -47,6 +47,7 @@
 #include <net/if.h>
 #include <net/if_types.h>
 #include <net/route.h>
+#include <net/vnet.h>
 
 #include <netinet/in.h>
 #include <netinet/in_pcb.h>
@@ -60,7 +61,6 @@
 #include <netinet/tcp_var.h>
 #include <netinet/tcpip.h>
 #include <netinet/icmp_var.h>
-#include <netinet/vinet.h>
 
 #ifdef IPSEC
 #include <netipsec/ipsec.h>
@@ -77,61 +77,75 @@
  * host table maintenance routines.
  */
 
-#ifdef VIMAGE_GLOBALS
-struct icmpstat	icmpstat;
-static int	icmpmaskrepl;
-static u_int	icmpmaskfake;
-static int	drop_redirect;
-static int	log_redirect;
-static int	icmplim;
-static int	icmplim_output;
-static char	reply_src[IFNAMSIZ];
-static int	icmp_rfi;
-static int	icmp_quotelen;
-static int	icmpbmcastecho;
-#endif
+VNET_DEFINE(struct icmpstat, icmpstat);
+static VNET_DEFINE(int, icmpmaskrepl);
+static VNET_DEFINE(u_int, icmpmaskfake);
+static VNET_DEFINE(int, drop_redirect);
+static VNET_DEFINE(int, log_redirect);
+static VNET_DEFINE(int, icmplim);
+static VNET_DEFINE(int, icmplim_output);
+static VNET_DEFINE(char, reply_src[IFNAMSIZ]);
+static VNET_DEFINE(int, icmp_rfi);
+static VNET_DEFINE(int, icmp_quotelen);
+static VNET_DEFINE(int, icmpbmcastecho);
 
-SYSCTL_V_STRUCT(V_NET, vnet_inet, _net_inet_icmp, ICMPCTL_STATS, stats,
-	CTLFLAG_RW, icmpstat, icmpstat, "");
+#define	V_icmpmaskrepl			VNET_GET(icmpmaskrepl)
+#define	V_icmpmaskfake			VNET_GET(icmpmaskfake)
+#define	V_drop_redirect			VNET_GET(drop_redirect)
+#define	V_log_redirect			VNET_GET(log_redirect)
+#define	V_icmplim			VNET_GET(icmplim)
+#define	V_icmplim_output		VNET_GET(icmplim_output)
+#define	V_reply_src			VNET_GET(reply_src)
+#define	V_icmp_rfi			VNET_GET(icmp_rfi)
+#define	V_icmp_quotelen			VNET_GET(icmp_quotelen)
+#define	V_icmpbmcastecho		VNET_GET(icmpbmcastecho)
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_icmp, ICMPCTL_MASKREPL, maskrepl,
-	CTLFLAG_RW, icmpmaskrepl, 0,
+SYSCTL_VNET_STRUCT(_net_inet_icmp, ICMPCTL_STATS, stats, CTLFLAG_RW,
+	&VNET_NAME(icmpstat), icmpstat, "");
+
+SYSCTL_VNET_INT(_net_inet_icmp, ICMPCTL_MASKREPL, maskrepl, CTLFLAG_RW,
+	&VNET_NAME(icmpmaskrepl), 0,
 	"Reply to ICMP Address Mask Request packets.");
 
-SYSCTL_V_UINT(V_NET, vnet_inet, _net_inet_icmp, OID_AUTO, maskfake, CTLFLAG_RW,
-	icmpmaskfake, 0, "Fake reply to ICMP Address Mask Request packets.");
+SYSCTL_VNET_UINT(_net_inet_icmp, OID_AUTO, maskfake, CTLFLAG_RW,
+	&VNET_NAME(icmpmaskfake), 0,
+	"Fake reply to ICMP Address Mask Request packets.");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_icmp, OID_AUTO, drop_redirect,
-	CTLFLAG_RW, drop_redirect, 0, "Ignore ICMP redirects");
+SYSCTL_VNET_INT(_net_inet_icmp, OID_AUTO, drop_redirect, CTLFLAG_RW,
+	&VNET_NAME(drop_redirect), 0,
+	"Ignore ICMP redirects");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_icmp, OID_AUTO, log_redirect,
-	CTLFLAG_RW, log_redirect, 0, "Log ICMP redirects to the console");
+SYSCTL_VNET_INT(_net_inet_icmp, OID_AUTO, log_redirect, CTLFLAG_RW,
+	&VNET_NAME(log_redirect), 0,
+	"Log ICMP redirects to the console");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_icmp, ICMPCTL_ICMPLIM, icmplim,
-	CTLFLAG_RW, icmplim, 0, "Maximum number of ICMP responses per second");
+SYSCTL_VNET_INT(_net_inet_icmp, ICMPCTL_ICMPLIM, icmplim, CTLFLAG_RW,
+	&VNET_NAME(icmplim), 0,
+	"Maximum number of ICMP responses per second");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_icmp, OID_AUTO, icmplim_output,
-	CTLFLAG_RW, icmplim_output, 0,
+SYSCTL_VNET_INT(_net_inet_icmp, OID_AUTO, icmplim_output, CTLFLAG_RW,
+	&VNET_NAME(icmplim_output), 0,
 	"Enable rate limiting of ICMP responses");
 
-SYSCTL_V_STRING(V_NET, vnet_inet, _net_inet_icmp, OID_AUTO, reply_src,
-	CTLFLAG_RW, reply_src, IFNAMSIZ,
+SYSCTL_VNET_STRING(_net_inet_icmp, OID_AUTO, reply_src, CTLFLAG_RW,
+	&VNET_NAME(reply_src), IFNAMSIZ,
 	"icmp reply source for non-local packets.");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_icmp, OID_AUTO, reply_from_interface,
-	CTLFLAG_RW, icmp_rfi, 0, "ICMP reply from incoming interface for "
-	"non-local packets");
+SYSCTL_VNET_INT(_net_inet_icmp, OID_AUTO, reply_from_interface, CTLFLAG_RW,
+	&VNET_NAME(icmp_rfi), 0,
+	"ICMP reply from incoming interface for non-local packets");
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_icmp, OID_AUTO, quotelen, CTLFLAG_RW,
-	icmp_quotelen, 0, "Number of bytes from original packet to "
-	"quote in ICMP reply");
+SYSCTL_VNET_INT(_net_inet_icmp, OID_AUTO, quotelen, CTLFLAG_RW,
+	&VNET_NAME(icmp_quotelen), 0,
+	"Number of bytes from original packet to quote in ICMP reply");
 
 /*
  * ICMP broadcast echo sysctl
  */
 
-SYSCTL_V_INT(V_NET, vnet_inet, _net_inet_icmp, OID_AUTO, bmcastecho,
-	CTLFLAG_RW, icmpbmcastecho, 0, "");
+SYSCTL_VNET_INT(_net_inet_icmp, OID_AUTO, bmcastecho, CTLFLAG_RW,
+	&VNET_NAME(icmpbmcastecho), 0,
+	"");
 
 
 #ifdef ICMPPRINTFS
@@ -146,7 +160,6 @@
 void
 icmp_init(void)
 {
-	INIT_VNET_INET(curvnet);
 
 	V_icmpmaskrepl = 0;
 	V_icmpmaskfake = 0;
@@ -166,7 +179,6 @@
 void
 icmp_error(struct mbuf *n, int type, int code, uint32_t dest, int mtu)
 {
-	INIT_VNET_INET(curvnet);
 	register struct ip *oip = mtod(n, struct ip *), *nip;
 	register unsigned oiphlen = oip->ip_hl << 2;
 	register struct icmp *icp;
@@ -315,7 +327,6 @@
 void
 icmp_input(struct mbuf *m, int off)
 {
-	INIT_VNET_INET(curvnet);
 	struct icmp *icp;
 	struct in_ifaddr *ia;
 	struct ip *ip = mtod(m, struct ip *);
@@ -649,7 +660,6 @@
 static void
 icmp_reflect(struct mbuf *m)
 {
-	INIT_VNET_INET(curvnet);
 	struct ip *ip = mtod(m, struct ip *);
 	struct ifaddr *ifa;
 	struct ifnet *ifp;
@@ -941,7 +951,6 @@
 int
 badport_bandlim(int which)
 {
-	INIT_VNET_INET(curvnet);
 
 #define	N(a)	(sizeof (a) / sizeof (a[0]))
 	static struct rate {
Index: sys/netinet/tcp_offload.c
===================================================================
--- sys/netinet/tcp_offload.c	(revision 195689)
+++ sys/netinet/tcp_offload.c	(working copy)
@@ -51,7 +51,6 @@
 #include <netinet/tcp_var.h>
 #include <netinet/tcp_offload.h>
 #include <netinet/toedev.h>
-#include <netinet/vinet.h>
 
 uint32_t toedev_registration_count;
 
@@ -109,7 +108,6 @@
 void
 tcp_offload_twstart(struct tcpcb *tp)
 {
-	INIT_VNET_INET(curvnet);
 
 	INP_INFO_WLOCK(&V_tcbinfo);
 	INP_WLOCK(tp->t_inpcb);
@@ -120,8 +118,7 @@
 struct tcpcb *
 tcp_offload_close(struct tcpcb *tp)
 {
-	INIT_VNET_INET(curvnet);
-	
+
 	INP_INFO_WLOCK(&V_tcbinfo);
 	INP_WLOCK(tp->t_inpcb);
 	tp = tcp_close(tp);
@@ -135,8 +132,7 @@
 struct tcpcb *
 tcp_offload_drop(struct tcpcb *tp, int error)
 {
-	INIT_VNET_INET(curvnet);
-	
+
 	INP_INFO_WLOCK(&V_tcbinfo);
 	INP_WLOCK(tp->t_inpcb);
 	tp = tcp_drop(tp, error);
Index: sys/netinet/ip_options.c
===================================================================
--- sys/netinet/ip_options.c	(revision 195689)
+++ sys/netinet/ip_options.c	(working copy)
@@ -62,7 +62,6 @@
 #include <netinet/ip_options.h>
 #include <netinet/ip_icmp.h>
 #include <machine/in_cksum.h>
-#include <netinet/vinet.h>
 
 #include <sys/socketvar.h>
 
@@ -98,7 +97,6 @@
 int
 ip_dooptions(struct mbuf *m, int pass)
 {
-	INIT_VNET_INET(curvnet);
 	struct ip *ip = mtod(m, struct ip *);
 	u_char *cp;
 	struct in_ifaddr *ia;
Index: sys/netinet/in_var.h
===================================================================
--- sys/netinet/in_var.h	(revision 195689)
+++ sys/netinet/in_var.h	(working copy)
@@ -102,12 +102,15 @@
  */
 TAILQ_HEAD(in_ifaddrhead, in_ifaddr);
 LIST_HEAD(in_ifaddrhashhead, in_ifaddr);
-#ifdef VIMAGE_GLOBALS
-extern	struct in_ifaddrhashhead *in_ifaddrhashtbl;
-extern	struct in_ifaddrhead in_ifaddrhead;
-extern	u_long in_ifaddrhmask;			/* mask for hash table */
-#endif
 
+VNET_DECLARE(struct in_ifaddrhashhead *, in_ifaddrhashtbl);
+VNET_DECLARE(struct in_ifaddrhead, in_ifaddrhead);
+VNET_DECLARE(u_long, in_ifaddrhmask);		/* mask for hash table */
+
+#define	V_in_ifaddrhashtbl	VNET_GET(in_ifaddrhashtbl)
+#define	V_in_ifaddrhead		VNET_GET(in_ifaddrhead)
+#define	V_in_ifaddrhmask	VNET_GET(in_ifaddrhmask)
+
 #define INADDR_NHASH_LOG2       9
 #define INADDR_NHASH		(1 << INADDR_NHASH_LOG2)
 #define INADDR_HASHVAL(x)	fnv_32_buf((&(x)), sizeof(x), FNV1_32_INIT)
@@ -345,11 +348,6 @@
 SYSCTL_DECL(_net_inet_raw);
 #endif
 
-LIST_HEAD(in_multihead, in_multi);	/* XXX unused */
-#ifdef VIMAGE_GLOBALS
-extern struct in_multihead in_multihead;
-#endif
-
 /*
  * Lock macros for IPv4 layer multicast address lists.  IPv4 lock goes
  * before link layer multicast locks in the lock order.  In most cases,
Index: sys/netinet/ip_var.h
===================================================================
--- sys/netinet/ip_var.h	(revision 195689)
+++ sys/netinet/ip_var.h	(working copy)
@@ -129,6 +129,8 @@
 
 #ifdef _KERNEL
 
+#include <net/vnet.h>
+
 #define	IPSTAT_ADD(name, val)	V_ipstat.name += (val)
 #define	IPSTAT_SUB(name, val)	V_ipstat.name -= (val)
 #define	IPSTAT_INC(name)	IPSTAT_ADD(name, 1)
@@ -158,20 +160,28 @@
 struct route;
 struct sockopt;
 
-#ifdef VIMAGE_GLOBALS
-extern struct	ipstat	ipstat;
-extern u_short	ip_id;			/* ip packet ctr, for ids */
-extern int	ip_do_randomid;
-extern int	ip_defttl;		/* default IP ttl */
-extern int	ipforwarding;		/* ip forwarding */
+VNET_DECLARE(struct ipstat, ipstat);
+VNET_DECLARE(u_short, ip_id);			/* ip packet ctr, for ids */
+VNET_DECLARE(int, ip_defttl);			/* default IP ttl */
+VNET_DECLARE(int, ipforwarding);		/* ip forwarding */
 #ifdef IPSTEALTH
-extern int	ipstealth;		/* stealth forwarding */
+VNET_DECLARE(int, ipstealth);			/* stealth forwarding */
 #endif
-extern int rsvp_on;
-extern struct socket *ip_rsvpd;		/* reservation protocol daemon */
-extern struct socket *ip_mrouter;	/* multicast routing daemon */
-#endif /* VIMAGE_GLOBALS */
+VNET_DECLARE(int, rsvp_on);
+VNET_DECLARE(struct socket *, ip_rsvpd);	/* reservation protocol daemon*/
+VNET_DECLARE(struct socket *, ip_mrouter);	/* multicast routing daemon */
 
+#define	V_ipstat		VNET_GET(ipstat)
+#define	V_ip_id			VNET_GET(ip_id)
+#define	V_ip_defttl		VNET_GET(ip_defttl)
+#define	V_ipforwarding		VNET_GET(ipforwarding)
+#ifdef IPSTEALTH
+#define	V_ipstealth		VNET_GET(ipstealth)
+#endif
+#define	V_rsvp_on		VNET_GET(rsvp_on)
+#define	V_ip_rsvpd		VNET_GET(ip_rsvpd)
+#define	V_ip_mrouter		VNET_GET(ip_mrouter)
+
 extern u_char	ip_protox[];
 extern int	(*legal_vif_num)(int);
 extern u_long	(*ip_mcast_src)(int);
@@ -231,6 +241,12 @@
 extern int	(*ip_dn_ctl_ptr)(struct sockopt *);
 extern int	(*ip_dn_io_ptr)(struct mbuf **m, int dir, struct ip_fw_args *fwa);
 extern void	(*ip_dn_ruledel_ptr)(void *);		/* in ip_fw2.c */
+
+VNET_DECLARE(int, ip_do_randomid);
+#define	V_ip_do_randomid	VNET_GET(ip_do_randomid)
+#define	ip_newid()	((V_ip_do_randomid != 0) ? ip_randomid() : \
+			    htons(V_ip_id++))
+
 #endif /* _KERNEL */
 
 #endif /* !_NETINET_IP_VAR_H_ */
